extension IterableX<E> on List<E> {
  bool equalTo(List<E> another) {
    if (another == null) {
      return false;
    }
    if (this.length != another.length) {
      return false;
    }
    for (int i = 0; i < length; ++i) {
      if (this[i] != another[i]) {
        return false;
      }
    }
    return true;
  }

  List<String> get convertToListString {
    return this.map((e) => e.toString()).toList();
  }

  E tryGet(int index) => index < 0 || index >= this.length ? null : this[index];
}

Iterable<int> intRange(int start, int end) {
  assert(end >= start);
  return Iterable.generate(end - start + 1, (i) => i + start);
}

typedef EveryWithIndex<E, R> = R Function(E element, int index);

String iterableTest = 'iterableTest';
